/**
 * http://www.stat.ubc.ca/~bouchard/GEP/README-usage.html
 * 
 * @author Alexandre Bouchard
 * @author Ardavan Saeedi
 */
package gep.comparisons;
import java.util.List;

import fig.basic.LogInfo;
import gep.timeseries.Measurements;

import nuts.util.Counter;


public class FlatReconstructionMethod implements HeldoutReconstructionMethod
{
  public static FlatReconstructionMethod mleFlatRecon(List<Measurements> observations) 
  {
    Counter<Integer> freqs = new Counter<Integer>();
    for (Measurements m : observations)
      for (int i = 0; i < m.size(); i++)
        freqs.incrementCount(m.getValue(i), 1.0);
    freqs.normalize();
    LogInfo.logs("Frequencies:" + freqs);
    return new FlatReconstructionMethod((int) (freqs.argMax()));
  }
  
  private int recon;
  public FlatReconstructionMethod(int recon) { this.recon = recon; }
  @Override
  public int reconstruct(int sIdx, int qIdx) { return recon; }
}