/**
 * http://www.stat.ubc.ca/~bouchard/GEP/README-usage.html
 * 
 * @author Alexandre Bouchard
 * @author Ardavan Saeedi
 */
package gep.data;
import java.io.File;
import java.util.Random;

import ma.MSAPoset;
import nuts.io.IO;
import pty.RootedTree;
import pty.UnrootedTree;
import ev.io.PreprocessGutellData;
import ev.to.PhyML;
import fig.basic.Option;
import fig.exec.Execution;


public class CreateTreeAlignment implements Runnable
{
  @Option public String gutellLocation;
  @Option public int nTaxa = 50;
  @Option public Random rand = new Random(1);
  
  public static PhyML phyML = new PhyML();

  public static void main(String[] args)
  {
    IO.run(args, new CreateTreeAlignment(), "phyml", phyML);
  }

  @Override
  public void run()
  {
    // get msa
    MSAPoset msa = PreprocessGutellData.randomDataSet(new File(gutellLocation), 1, nTaxa, rand ).get(0);
    UnrootedTree unrooted = UnrootedTree.fromRooted(phyML.inferTree(msa.toMultiAlignmentObject()));
    RootedTree rooted = RootedTree.Util.centroidRooting(unrooted);
    // print out stuff
    msa.toMultiAlignmentObject().saveToMSF(new File(Execution.getFile("msa.msf")));
    IO.writeToDisk(new File(Execution.getFile("tree.newick")),RootedTree.Util.toNewick(rooted));
  }

}
