/**
 * http://www.stat.ubc.ca/~bouchard/GEP/README-usage.html
 * 
 * @author Alexandre Bouchard
 * @author Ardavan Saeedi
 */
package gep.timeseries;
import java.util.Collections;
import java.util.List;

import nuts.util.Indexer;


public class Measurements
{
  private final List<Double> times;
  private final List<Integer> values;
  public double getTime(int idx) { return times.get(idx); }
  public int getValue(int idx) { return values.get(idx); }
  public List<Double> getTimes() { return Collections.unmodifiableList(times); }
  public List<Integer> getValues() { return Collections.unmodifiableList(values); }
  public Measurements(List<Double> times, List<Integer> values)
  {
//    System.out.println("times:" + times);
    this.times = times;
    this.values = values;
    if (times.size() != values.size())
      throw new RuntimeException();
  }
  @SuppressWarnings("unchecked")
  public String toString(Indexer indexer)
  {
    StringBuilder result = new StringBuilder();
    for (int i = 0; i < size(); i++)
      result.append("" + (indexer== null ? values.get(i) : indexer.i2o(values.get(i))) + "@" + times.get(i)  + "\n");
    return result.toString();
  }
  @Override
  public String toString()
  {
    return toString(null);
  }
  public int size()
  {
    return times.size();
  }
}